#ifndef BOOKA_H
#define BOOKA_H

#include <stddef.h>
#include "setup.h"
#include "handle.h"

#ifdef __cplusplus
extern "C" 
{
#endif

    XLAPI     BookHandle XLAPIENTRY xlCreateBookCA();

    XLAPI            int XLAPIENTRY xlBookLoadA(BookHandle handle, const char* filename);
    XLAPI            int XLAPIENTRY xlBookSaveA(BookHandle handle, const char* filename);

    XLAPI    SheetHandle XLAPIENTRY xlBookAddSheetA(BookHandle handle, const char* name);
    XLAPI    SheetHandle XLAPIENTRY xlBookGetSheetA(BookHandle handle, unsigned short index);
    XLAPI            int XLAPIENTRY xlBookDelSheetA(BookHandle handle, unsigned short index);
    XLAPI unsigned short XLAPIENTRY xlBookSheetCountA(BookHandle handle);

    XLAPI   FormatHandle XLAPIENTRY xlBookAddFormatA(BookHandle handle, FormatHandle initFormat);
    XLAPI     FontHandle XLAPIENTRY xlBookAddFontA(BookHandle handle, FontHandle initFont);
    XLAPI       unsigned XLAPIENTRY xlBookAddCustomNumFormatA(BookHandle handle, const char* customNumFormat);
    XLAPI    const char* XLAPIENTRY xlBookCustomNumFormatA(BookHandle handle, unsigned fmt);

    XLAPI         double XLAPIENTRY xlBookDatePackA(BookHandle handle, unsigned short year, unsigned short month, unsigned short day,
                                                                       unsigned short hour, unsigned short min, unsigned short sec);

    XLAPI            int XLAPIENTRY xlBookDateUnpackA(BookHandle handle, double value, unsigned short* year, unsigned short* month, unsigned short* day,
                                                                                       unsigned short* hour, unsigned short* min, unsigned short* sec);

    XLAPI unsigned short XLAPIENTRY xlBookActiveSheetA(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetActiveSheetA(BookHandle handle, unsigned short index);

    XLAPI            int XLAPIENTRY xlBookAddPictureA(BookHandle handle, const char* filename);

    XLAPI           void XLAPIENTRY xlBookSetKeyA(BookHandle handle, const wchar_t* name, const wchar_t* key);
    XLAPI           void XLAPIENTRY xlBookSetLocaleA(BookHandle handle, const char* locale);
    XLAPI    const char* XLAPIENTRY xlBookErrorMessageA(BookHandle handle);

    XLAPI           void XLAPIENTRY xlBookReleaseA(BookHandle handle);

#ifdef __cplusplus
}
#endif

#endif
