#ifndef SHEETA_H
#define SHEETA_H

#include "setup.h"
#include "handle.h"
#include "enum.h"

#ifdef __cplusplus
extern "C" 
{
#endif

    XLAPI            int XLAPIENTRY xlSheetCellTypeA(SheetHandle handle, unsigned short row, unsigned short col);

    XLAPI    const char* XLAPIENTRY xlSheetReadStrA(SheetHandle handle, unsigned short row, unsigned short col, FormatHandle* format);
    XLAPI            int XLAPIENTRY xlSheetWriteStrA(SheetHandle handle, unsigned short row, unsigned short col, const char* value, FormatHandle format);

    XLAPI         double XLAPIENTRY xlSheetReadNumA(SheetHandle handle, unsigned short row, unsigned short col, FormatHandle* format);
    XLAPI            int XLAPIENTRY xlSheetWriteNumA(SheetHandle handle, unsigned short row, unsigned short col, double value, FormatHandle format);

    XLAPI            int XLAPIENTRY xlSheetReadBoolA(SheetHandle handle, unsigned short row, unsigned short col, FormatHandle* format);
    XLAPI            int XLAPIENTRY xlSheetWriteBoolA(SheetHandle handle, unsigned short row, unsigned short col, int value, FormatHandle format);

    XLAPI            int XLAPIENTRY xlSheetReadBlankA(SheetHandle handle, unsigned short row, unsigned short col, FormatHandle* format);
    XLAPI            int XLAPIENTRY xlSheetWriteBlankA(SheetHandle handle, unsigned short row, unsigned short col, FormatHandle format);

    XLAPI    const char* XLAPIENTRY xlSheetReadCommentA(SheetHandle handle, unsigned short row, unsigned short col);
    XLAPI           void XLAPIENTRY xlSheetWriteCommentA(SheetHandle handle, unsigned short row, unsigned short col, const char* value, const char* author, int width, int height);

    XLAPI            int XLAPIENTRY xlSheetIsDateA(SheetHandle handle, unsigned short row, unsigned short col);
    XLAPI            int XLAPIENTRY xlSheetReadErrorA(SheetHandle handle, unsigned short row, unsigned short col);

    XLAPI         double XLAPIENTRY xlSheetColWidthA(SheetHandle handle, unsigned short col);
    XLAPI         double XLAPIENTRY xlSheetRowHeightA(SheetHandle handle, unsigned short row);

    XLAPI            int XLAPIENTRY xlSheetSetColA(SheetHandle handle, unsigned short colFirst, unsigned short colLast, double width, FormatHandle format, int hidden);
    XLAPI            int XLAPIENTRY xlSheetSetRowA(SheetHandle handle, unsigned short row, double height, FormatHandle format, int hidden);

    XLAPI            int XLAPIENTRY xlSheetGetMergeA(SheetHandle handle, unsigned short row, unsigned short col, unsigned short* rowFirst, unsigned short* rowLast, unsigned short* colFirst, unsigned short* colLast);
    XLAPI            int XLAPIENTRY xlSheetSetMergeA(SheetHandle handle, unsigned short rowFirst, unsigned short rowLast, unsigned short colFirst, unsigned short colLast);

    XLAPI           void XLAPIENTRY xlSheetSetPictureA(SheetHandle handle, unsigned short row, unsigned short col, int pictureId, double scale);
    XLAPI           void XLAPIENTRY xlSheetSetPicture2A(SheetHandle handle, unsigned short row, unsigned short col, int pictureId, int width, int height);

    XLAPI            int XLAPIENTRY xlSheetSetHorPageBreakA(SheetHandle handle, unsigned short row, int pageBreak);
    XLAPI            int XLAPIENTRY xlSheetSetVerPageBreakA(SheetHandle handle, unsigned short col, int pageBreak);

    XLAPI           void XLAPIENTRY xlSheetSplitA(SheetHandle handle, unsigned short row, unsigned short col);    

    XLAPI            int XLAPIENTRY xlSheetGroupRowsA(SheetHandle handle, unsigned short rowFirst, unsigned rowLast, int collapsed);
    XLAPI            int XLAPIENTRY xlSheetGroupColsA(SheetHandle handle, unsigned short colFirst, unsigned colLast, int collapsed);

    XLAPI           void XLAPIENTRY xlSheetClearA(SheetHandle handle, unsigned short rowFirst, unsigned short rowLast, unsigned short colFirst, unsigned short colLast);

    XLAPI unsigned short XLAPIENTRY xlSheetFirstRowA(SheetHandle handle);
    XLAPI unsigned short XLAPIENTRY xlSheetLastRowA(SheetHandle handle);
    XLAPI unsigned short XLAPIENTRY xlSheetFirstColA(SheetHandle handle);
    XLAPI unsigned short XLAPIENTRY xlSheetLastColA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetDisplayGridlinesA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetDisplayGridlinesA(SheetHandle handle, int show);

    XLAPI            int XLAPIENTRY xlSheetPrintGridlinesA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintGridlinesA(SheetHandle handle, int print);

    XLAPI       unsigned XLAPIENTRY xlSheetZoomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetZoomA(SheetHandle handle, unsigned zoom);

    XLAPI       unsigned XLAPIENTRY xlSheetPrintZoomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintZoomA(SheetHandle handle, unsigned zoom);

    XLAPI            int XLAPIENTRY xlSheetLandscapeA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetLandscapeA(SheetHandle handle, int landscape);

    XLAPI            int XLAPIENTRY xlSheetPaperA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPaperA(SheetHandle handle, int paper);

    XLAPI    const char* XLAPIENTRY xlSheetHeaderA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetSetHeaderA(SheetHandle handle, const char* header, double margin);
    XLAPI         double XLAPIENTRY xlSheetHeaderMarginA(SheetHandle handle);

    XLAPI    const char* XLAPIENTRY xlSheetFooterA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetSetFooterA(SheetHandle handle, const char* footer, double margin);
    XLAPI         double XLAPIENTRY xlSheetFooterMarginA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetHCenterA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetHCenterA(SheetHandle handle, int hCenter);

    XLAPI            int XLAPIENTRY xlSheetVCenterA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetVCenterA(SheetHandle handle, int vCenter);

    XLAPI         double XLAPIENTRY xlSheetMarginLeftA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginLeftA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginRightA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginRightA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginTopA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginTopA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginBottomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginBottomA(SheetHandle handle, double margin);

    XLAPI            int XLAPIENTRY xlSheetPrintRowColA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintRowColA(SheetHandle handle, int print);

    XLAPI    const char* XLAPIENTRY xlSheetNameA(SheetHandle handle);

#ifdef __cplusplus
}
#endif

#endif
